"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@fusion.io/core");
const Validator_1 = __importDefault(require("./Validator"));
const rules_1 = require("./rules");
class Plasma extends core_1.Plasma {
    static get ChrisOharaValidators() {
        return {
            contains: 'contains',
            equals: 'equals',
            isAfter: 'date.after',
            isAlpha: 'alpha',
            isAlphanumeric: 'alphaNumeric',
            isAscii: 'ascii',
            isBase32: 'base32',
            isBase64: 'base64',
            isBefore: 'date.before',
            isBoolean: 'boolean',
            isCreditCard: 'creditcard',
            isCurrency: 'currency',
            isDataURI: 'dataURI',
            isMagnetURI: 'magnetURI',
            isDecimal: 'decimal',
            isDivisibleBy: 'divisible',
            isEmail: 'email',
            isEmpty: 'empty',
            isFQDN: 'domain',
            isFloat: 'float',
            isFullWidth: 'fullwidth',
            isHalfWidth: 'halfwidth',
            isHash: 'hash',
            isHexColor: 'hexcolor',
            isHexadecimal: 'hexa',
            isIdentityCard: 'idcard',
            isIP: 'ip',
            isIPRange: 'ipv4range',
            isISSN: 'issn',
            isISIN: 'isin',
            isISO8601: 'date.iso8601',
            isRFC3339: 'date.rfc3339',
            isInt: 'int',
            isJSON: 'json',
            isJWT: 'jwt',
            isLatLong: 'latlong',
            isLength: 'length',
            isLowercase: 'lowercase',
            isMACAddress: 'macAddress',
            isMD5: 'md5',
            isMimeType: 'mime',
            isMobilePhone: 'phone',
            isMongoId: 'mongoID',
            isMultibyte: 'hasMultibyte',
            isNumeric: 'numeric',
            isPostalCode: 'postcode',
            isURL: 'url',
            isUppercase: 'uppercase',
            matches: 'matches'
        };
    }
    compose(validator) {
        const nativeValidators = require("validator");
        for (let nativeName in Plasma.ChrisOharaValidators) {
            if (Plasma.ChrisOharaValidators.hasOwnProperty(nativeName)) {
                let desiredName = Plasma.ChrisOharaValidators[nativeName];
                validator.extends(desiredName, (value, ...args) => {
                    return nativeValidators[nativeName](value + '', ...args);
                });
            }
        }
        validator
            .extends('*', rules_1.nope)
            .extends('required', rules_1.required)
            .extends('array', rules_1.array);
        validator.supporting('ajv', (_a) => {
            var { schemas } = _a, options = __rest(_a, ["schemas"]);
            const Ajv = require('ajv');
            const ajv = new Ajv(options);
            Object.entries(schemas).forEach(([name, schema]) => {
                ajv.addSchema(schema, name);
            });
            return (value, schema, context) => __awaiter(this, void 0, void 0, function* () {
                const result = yield ajv.validate(schema, value);
                context.errors = ajv.errors;
                return result;
            });
        });
    }
    boot(validator) {
        validator.configure(this.config.validation);
    }
}
__decorate([
    core_1.inject(Validator_1.default),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Validator_1.default]),
    __metadata("design:returntype", void 0)
], Plasma.prototype, "compose", null);
__decorate([
    core_1.inject(Validator_1.default),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Validator_1.default]),
    __metadata("design:returntype", void 0)
], Plasma.prototype, "boot", null);
exports.default = Plasma;
//# sourceMappingURL=Plasma.js.map